
import inspect
import os,sys

'''
------------------------------------------------------------
デバッグ関数
（自由にカスタマイズして使って下さい）

画面（コマンドラインのコンソール）と
ファイル(dbg.txt)に出力されます。

フォーマットは以下（このスクリプトを実行した場合）
dbg.py <module>:76 ()                           # 呼出 dbg()
dbg.py main:72 (1, 2)                           # 呼出 dbg( a,b )
dbg.py func:68 {'i': 123, 'data': 'コバヤシ'}   # 呼出 dbgKw( i=i, data=data )



FNAME
　ファイル名、フォルダを追加すれば指定フォルダに出力されます

dbgWrt関数のfmtを変更して好きなフォーマットにして下さい
------------------------------------------------------------
'''

FNAME = "dbg.txt"           # File Name


#ファイル内容をクリアしている
#(importした時に一度だけ実行されます)
f =open( FNAME,"w" )
f.close()


def dbgWrt( arg, fileNm, funcNm, lineNo  ):

  # Output Format (ファイル名、関数名、行番号、引数) 
  fmt = "%s %s:%s %s" %( fileNm, funcNm, lineNo, arg) 
  print( fmt, flush=True )
  with open( FNAME, "a" ) as f:
    f.write( fmt + "\n" )
    

def dbg( *arg ):
  frame = inspect.currentframe().f_back
  fileNm = os.path.basename(frame.f_code.co_filename)
  funcNm = frame.f_code.co_name
  lineNo = frame.f_lineno
  dbgWrt( arg, fileNm, funcNm, lineNo )


def dbgKw( **kwa ):
  frame = inspect.currentframe().f_back
  fileNm = os.path.basename(frame.f_code.co_filename)
  funcNm = frame.f_code.co_name
  lineNo = frame.f_lineno
  dbgWrt( kwa, fileNm, funcNm, lineNo )




if  __name__ == "__main__":
    
    def func():
      i=123
      data ="コバヤシ"
      dbgKw( i=i, data=data )

    def main():
      a,b,c =(1,2,3)
      dbg( a,b )
      func()


    dbg()               # 引数無しでトレースを行う
    main()


